type 'a t

val create : unit -> 'a t
val empty : unit -> 'a t

val add : 'a t -> 'a -> unit
val ( ++ ) : 'a t -> 'a -> 'a t 

val to_string : ('a -> string) -> 'a t -> string 
val make : 'a list -> 'a t
val remove : 'a t -> 'a -> unit

val mem : 'a t -> 'a -> bool

val iter : 'a t -> ('a -> unit) -> unit 
val fold : ('a -> 'b -> 'b) -> 'a t -> 'b -> 'b

val ( -- ) : 'a t -> 'a -> 'a t 
val intersect : 'a t -> 'a t -> 'a t 
val ( ** ) : 'a t -> 'a t -> 'a t 
val copy : 'a t -> 'a t 
val forall : 'a t -> ('a -> bool) -> bool 
val exists : 'a t -> ('a -> bool) -> bool 

val size : 'a t -> int

val is_empty : 'a t -> bool
val subset : 'a t -> 'a t -> bool
val cmp : 'a t -> 'a t -> bool
val toList : 'a t -> 'a list
